<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\Manager;
use Doctrine\ORM\EntityManager;
use Teknisa\CRM\Service\GeralService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\CRM\Controller\TeknisaCrud;
use Zeedhi\Framework\Util\Functions;

class crm00002001OportunidadeNegocioController extends TeknisaCrud {


    protected $dataSourceName = 'crm_oportuni_oportunidadenegocio';
    protected $fieldsFaseNego_dataSourceName = 'fieldsFaseNego';
    protected $parameterBagColumns = array('P_NRORG', 'P_NRPARCNEGOCIO', 'IDTPOPERADOR', 'NRREVENDA', 'P_DTININCLUSAO', 'P_DTFIMINCLUSAO', 'P_DTINIEVOLUCAO', 'P_DTFIMEVOLUCAO', 'P_CRM_NRORGTRAB');

        /** @var  EntityManager */
    protected $entityManager;
    protected $connection;
    protected $newCode;
    protected $geralService;
    protected $environment;
    protected $prospectService;
    protected $enviarMensagemController;
    protected $agendaDeTarefasController;
    
    protected $oportService;
    protected $oportFactory;

    public function __construct ($crudService, $parameterBag, $entityManager, $newCode,
        $geralService, $environment, $prospectService, $enviarMensagemController,
        $agendaDeTarefasController, $oportService, $oportFactory, $util) {
        $this->newCode                    = $newCode;
        $this->entityManager              = $entityManager;
        $this->geralService               = $geralService;
        $this->connection                 = $entityManager->getConnection();
        $this->environment                = $environment;
        $this->prospectService            = $prospectService;
        $this->enviarMensagemController   = $enviarMensagemController;
        $this->agendaDeTarefasController  = $agendaDeTarefasController;
        $this->util = $util;
        
        $this->oportService = $oportService;
        $this->oportFactory = $oportFactory;
        
        parent::__construct($crudService, $parameterBag);
    }
    
    public function findOportuniGeral(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'crm_oportuni_geral';
        $this->parameterBagColumns = array();
        parent::find($request, $response);
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'crm_oportuni_oportunidadenegocio';
        // $this->parameterBagColumns = array('IDTPOPERADOR', 'NRREVENDA');
        $request = $this->util->modifyDateFilter($request, 'DINCLUSAO', 'P_DTININCLUSAO', 'P_DTFIMINCLUSAO');
        $request = $this->util->modifyDateFilter($request, 'ULTIMA_EVOLUCAO', 'P_DTINIEVOLUCAO', 'P_DTFIMEVOLUCAO');
        
        parent::find($request, $response);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
    	$this->dataSourceName = 'saveOportunidade';
    	foreach($request->getDataSet()->getRows() as $row) {
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('VROPORT', $row)) {
                $row['VROPORT'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DTPREVFECHA', $row)) {
                $row['DTPREVFECHA'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('CDMODODIVULG', $row)) {
                $row['CDMODODIVULG'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DSOPORT', $row)) {
                $row['DSOPORT'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DTHRINIOPORTUNI', $row)) {
                $row['DTHRINIOPORTUNI'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DTREALFECHA', $row)) {
                $row['DTREALFECHA'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRSEQRESULEVOL', $row)) {
                $row['NRSEQRESULEVOL'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRCONCORRENTE', $row)) {
                $row['NRCONCORRENTE'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('DTULTATU', $row)) {
                $row['DTULTATU'] = null;
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('IDATIVO', $row)) {
                $row['IDATIVO'] = 'S';
            } 
            if (!\Zeedhi\Framework\Util\Functions::arrayKeyExists('NRTERMOPORTUNI', $row)) {
                $row['NRTERMOPORTUNI'] = null;
            } 
            
            if ($row['__is_new'] && (empty($row['NRSEQOPORT']))) {
                $row['NRSEQOPORT'] = $this->newCode->getCodeByTableName("OPORTUNIDADE9999", $row["NRORG"]);
                $row['DTINCLUSAO'] = new \DateTime();
                $row['DTINCLUSAO'] = $row['DTINCLUSAO']->format('d/m/Y H:i:s');
                $row["CDFILIAL"] = $this->environment->getCdFilial();
                $this->geralService->newContato($row);
                //Seta Erro se houver erro no Contato
                if(!empty($row['NRSEQCONTATO'])) {
                    $response->addDataSet(new DataSet("DADOS", array("NRSEQOPORT" => $row["NRSEQOPORT"], "NRCONTATO" => $row["NRSEQCONTATO"], "NRSEQCONTATO" => $row["NRSEQCONTATO"], "DTINCLUSAO" => $row["DTINCLUSAO"])));
                }else {
                    $response->setError(new Error('Não foi possível criar a oportunidade, os dados do prospect não foram encontrados.', 10));
                }
            } else {
                $this->oportService->setAuditColumns($row);
            }
        }
        //Não salva se houver erro no Contato
        if(!empty($row['NRSEQCONTATO'])){
            $notificaResponsavel = false;
            //Rotina de Email    
            if($row['__is_new']) {
                parent::save($request, $response);
                $valida = $this->verificaParametrizacao($row);
                $valida = 'responsavel';
                if($valida !== false) {
                    if($valida === 'responsavel') {
                        $notificaResponsavel = $this->validaResponsavelParc($row);
                    } else {
                        $perfilatividade = $valida;
                        $notificaResponsavel = $this->validaPerfilAtividade($row, $perfilatividade);
                    }
                }
                
                if(!empty($row['NRSEQCONTATO'])) {
                    $response->addDataSet(new DataSet("DADOS", array("NRSEQOPORT" => $row["NRSEQOPORT"], "NRCONTATO" => $row["NRSEQCONTATO"], "NRSEQCONTATO" => $row["NRSEQCONTATO"], "DTINCLUSAO" => $row["DTINCLUSAO"], 'ENVIAEMAIL' => $notificaResponsavel)));
                } else {
                    $response->setError(new Error('Não foi possível criar a oportunidade, os dados do prospect não foram encontrados.', 10));
                }
            } else {
                $this->edit($row);
                
                $response->addDataSet(new DataSet("DADOS", array("DTULTATU" => $row["DTULTATU"], 'ENVIAEMAIL' => false)));
            }
        }
    }
    
    public function edit($row) {
        $params = array(
            'NRORG'             =>  $row['NRORG'],
            'NRSEQOPORT'        =>  $row['NRSEQOPORT'],
            'NMOPORT'           =>  $row['NMOPORT'],
            'VRPREVOPORT'       =>  $row['VRPREVOPORT'],
            'NRPARCOPORT'       =>  $row['NRPARCOPORT'],
            'IDTPOPORT'         =>  $row['IDTPOPORT'],
            'NRPARCRESP'        =>  $row['NRPARCRESP'],
            'DTPREVFECHA'       =>  $row['DTPREVFECHA'],
            'CDMODODIVULG'      =>  $row['CDMODODIVULG'],
            'IDPARTPEPELINE'    =>  $row['IDPARTPEPELINE'],
            'DSOPORT'           =>  $row['DSOPORT'],
            'DTHRINIOPORTUNI'   =>  $row['DTHRINIOPORTUNI'],
            'VROPORT'           =>  $row['VROPORT'],
            'NRSEQFASENEGO'     =>  $row['NRSEQFASENEGO'],
            'CDFILIAL'          =>  $row['CDFILIAL'],
            'NRCONTATO'         =>  $row['NRCONTATO'],
            'NRSEQCONTATO'      =>  $row['NRSEQCONTATO'],
            'NRSEQCLASSOPORT'   =>  $row['NRSEQCLASSOPORT'],
            'IDATIVO'           =>  $row['IDATIVO'],
            'DTREALFECHA'       =>  $row['DTREALFECHA'],
            'NRSEQRESULEVOL'    =>  $row['NRSEQRESULEVOL'],
            'NRCONCORRENTE'     =>  $row['NRCONCORRENTE'],
            'NRTEMPOVIGENCIA'   =>  $row['NRTEMPOVIGENCIA'],
            'NRTERMOPORTUNI'    =>  $row['NRTERMOPORTUNI'],
            'CDOPERULTATU'      =>  $row['CDOPERULTATU'],
            'NRORGULTATU'       =>  $row['NRORGULTATU'],
            'DTULTATU'          =>  $row['DTULTATU']
        );
        
        $query = 
            "UPDATE
                CRM_OPORTUNI
            SET
                NMOPORT         = :NMOPORT,
                VRPREVOPORT     = :VRPREVOPORT,
                NRPARCOPORT     = :NRPARCOPORT,
                IDTPOPORT       = :IDTPOPORT,
                NRPARCRESP      = :NRPARCRESP,
                DTPREVFECHA     = :DTPREVFECHA,
                CDMODODIVULG    = :CDMODODIVULG,
                IDPARTPEPELINE  = :IDPARTPEPELINE,
                DSOPORT         = :DSOPORT,
                DTHRINIOPORTUNI = :DTHRINIOPORTUNI,
                VROPORT         = :VROPORT,
                NRSEQFASENEGO   = :NRSEQFASENEGO,
                CDFILIAL        = :CDFILIAL,
                NRCONTATO       = :NRCONTATO,
                NRSEQCONTATO    = :NRSEQCONTATO,
                NRSEQCLASSOPORT = :NRSEQCLASSOPORT,
                IDATIVO         = :IDATIVO,
                DTREALFECHA     = :DTREALFECHA,
                NRSEQRESULEVOL  = :NRSEQRESULEVOL,
                NRCONCORRENTE   = :NRCONCORRENTE,
                NRTEMPOVIGENCIA = :NRTEMPOVIGENCIA,
                NRTERMOPORTUNI  = :NRTERMOPORTUNI,
                DTULTATU        = :DTULTATU,
                CDOPERULTATU    = :CDOPERULTATU,
                NRORGULTATU     = :NRORGULTATU
            WHERE
                NRORG       =   :NRORG
                    AND
                NRSEQOPORT  =   :NRSEQOPORT";
                
        $std = $this->connection->prepare($query);
        $std->execute($params);
    }

    public function fecharOportunidade(Row $row, Response $response, $entityManager = null) {
        try {
            $fechamento = $row->getRow();
            
            self::closeOpportRelatedTasks($fechamento, $entityManager);
            
            $update = "UPDATE 
                         CRM_OPORTUNI
                       SET 
                         DTREALFECHA = :DTREALFECHA,
                         NRSEQRESULEVOL = :NRSEQRESULEVOL,
                         NRCONCORRENTE = :NRCONCORRENTE
                        WHERE
                          NRSEQOPORT = :NRSEQOPORT
                          AND NRORG = :NRORG
                          AND CRM_NRORGTRAB = :CRM_NRORGTRAB";
    
            $params = array (
                "NRORG"          => $fechamento["NRORG"],
                "CRM_NRORGTRAB"  => $fechamento["CRM_NRORGTRAB"],
                "NRSEQOPORT"     => $fechamento["NRSEQOPORT"],
                "DTREALFECHA"    => $fechamento["DTREALFECHA"],
                "NRSEQRESULEVOL" => isset($fechamento["NRSEQRESULEVOLOPORT"]) ? $fechamento["NRSEQRESULEVOLOPORT"] : $fechamento["NRSEQRESULEVOL"],
                "NRCONCORRENTE"  => $fechamento["NRCONCORRENTE"]
            );

            if(!empty($entityManager)) {
                $this->connection = $entityManager->getConnection();
            }
            $std = $this->connection->prepare($update);
            $std->execute($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function closeOpportRelatedTasks($row, $entityManager = null){
        
        $opportRelatedTasks = self::getOpportRelatedTasks($row, $entityManager);
        $response = new Response();
        
        if($opportRelatedTasks){
            
            foreach ($opportRelatedTasks as $task) {
                $row["NRSEQFILACONTA"] = $task['NRSEQFILACONTA'];
                
                $modifiedRow = new Row($row, null, null, null);
                $this->agendaDeTarefasController->concluirTarefa($modifiedRow, $response, $entityManager);
            }
            
        }
        
    }
    
    public function getOpportRelatedTasks($row, $entityManager = null){
        
        $selectParams = array(
            "NRSEQCONTATO"      => self::getOpportNrseqcontato($row, $entityManager),
            "NRORG"             => $row["NRORG"]
        );
        
        if($selectParams["NRSEQCONTATO"]){
                
            $select = "SELECT NRSEQFILACONTA
                        FROM FILACONTATO
                        WHERE DTREALFILACONTA IS NULL
                          AND (DTVENCFILACONTA < SYSDATE
                               OR (DTVENCFILACONTA IS NULL
                                   AND DTPLANFILACONTA < SYSDATE))
                          AND NRSEQCONTATO = :NRSEQCONTATO
                          AND NRORG = :NRORG";
            
            try {
                if(!empty($entityManager)){
                    $this->connection = $entityManager->getConnection();
                }
                $std = $this->connection->prepare($select);
                $std->execute($selectParams);
                $opportTasks = $std->fetchAll();
            }catch (Exception $e){
                throw $e;
            }
            
            return $opportTasks;    
            
        }
        
    }
    
    public function getOpportNrseqcontato($row, $entityManager = null){
        
        $selectParams = array(
            "NRSEQOPORT"        => $row["NRSEQOPORT"],
            "NRORG"             => $row["NRORG"]
        );
        
        $select = "SELECT NRSEQCONTATO
                    FROM CRM_OPORTUNI
                    WHERE NRSEQOPORT = :NRSEQOPORT
                    AND NRORG = :NRORG";
                    
        try {
            if(!empty($entityManager)){
                $this->connection = $entityManager->getConnection();
            }
            $std = $this->connection->prepare($select);
            $std->execute($selectParams);
            $response = $std->fetchAll();
        }catch(Exception $e){
            throw $e;
        }
        
        if(isset($response[0])){
            $nrseqcontato = $response[0]['NRSEQCONTATO'];
        }else{
            $nrseqcontato = null;
        }
        
        return $nrseqcontato;
        
    }
    
    public function verificaParametrizacao($row){
        $nrorg = $this->environment->getNrorg();
        
        $selectParametrizacao = "SELECT IDVALIDARESPOPORTUNI, NRSEQPERFATIV
                    FROM CRM_PARAMETRIZACAO 
                       WHERE NRORG = $nrorg";
                       
        try {
            $std = $this->connection->prepare($selectParametrizacao);
            $std->execute();
            $valida = $std->fetchAll();
            if(!empty($valida) && $valida[0]['IDVALIDARESPOPORTUNI'] === 'S' ){
                return 'responsavel';
            }else if(!empty($valida) && !empty($valida[0]['NRSEQPERFATIV'])){
                return $valida[0]['NRSEQPERFATIV'];        
            }else{
                return false;
            }
        }
        catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function validaResponsavelParc($row){
        $params = array (
            "NRPARCOPORT" => $row['NRPARCOPORT'],
            "NRORG"       => $this->environment->getNrorg()
        );
        $selectResponsavel = "SELECT CDOPERRESPONSAVEL
                    FROM PARCNEGOCIO 
                        WHERE NRPARCNEGOCIO = :NRPARCOPORT
                          AND NRORG         = :NRORG";
        try {
            $std = $this->connection->prepare($selectResponsavel);
            $std->execute($params);
            $cdoperresponsavel = $std->fetchAll();

            if(!empty($cdoperresponsavel) && !empty($cdoperresponsavel[0])){
                $cdoperresponsavel = $cdoperresponsavel[0]["CDOPERRESPONSAVEL"];
                
                if(!is_null($cdoperresponsavel) && $cdoperresponsavel !== $row['CDOPERADOR']){
                    return $cdoperresponsavel;
                } else {
                    return false;
                }
            }
        }
        catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function validaPerfilAtividade($row, $perfilatividade){
        $params = array (
            "NRSEQPERFATIV" => $perfilatividade,
            "NRORG"         => $this->environment->getNrorg()
        );
        $selectResponsavel = "SELECT CDOPERADOR
                    FROM CRM_PERFIOPER 
                        WHERE NRSEQPERFATIV = :NRSEQPERFATIV
                          AND NRORG         = :NRORG";
        try {
            $std = $this->connection->prepare($selectResponsavel);
            $std->execute($params);
            $responsaveisPerfil = $std->fetchAll();

            if(is_array($responsaveisPerfil) && !empty($responsaveisPerfil[0])){
                return $responsaveisPerfil;
            } else {
                return false;
            }
        }
        catch (\Exception $e) {
            throw $e;
        }
    }


    public function notificaResponsavelOportunidade($row, $cdoperresponsavel){
        
        $from = $this->environment->getCdOperador();
        
        $mensagem = array();
        $mensagem['DSMENSAGEM']       = '<table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee" style="background-color: #eeeeee;"> <tbody> <tr> <td> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="0274BA" class="container590" style="background-color: #0274ba; text-align: center;"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="center" valign="middle"> <table border="0" align="middle" cellpadding="0" cellspacing="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;" class=""> <tbody> <tr> <td align="center" valign="middle"> <p style="color: #ffffff; font-size: 25px; padding:20px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 25px; padding-top:45px;">NOTIFICAÇÃO DE OPORTUNIDADE </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> [NMOPORT] </p> <p style="color: #ffffff; font-size: 16px; font-family: "Questrial", Helvetica, sans-serif; line-height: 15px; padding-top:15px;">&nbsp;</p> <p style="color: #ffffff; font-size: 16px; font-family: " Questrial ", Helvetica, sans-serif; line-height: 15px; padding-top:15px;"> <br> </p> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> <table border="0" width="100%" cellpadding="0" cellspacing="0" bgcolor="eeeeee"> <tbody> <tr> <td align="center"> <table border="0" align="center" width="590" cellpadding="0" cellspacing="0" bgcolor="ffffff" class="container590 bg_color"> <tbody> <tr> <td> <table border="0" align="center" width="540" cellpadding="0" cellspacing="0" class="container580"> <tbody> <tr> <td align="left" style="color: #39434b; font-size: 20px; font-family: " Montserrat ", Helvetica, sans-serif; font-weight: 400; padding-bottom:15px; padding-top:20px; line-height: 35px;" class="title_color"> <div style="padding:20px; line-height: 22px"> Prezado(a) [RESPONSAVEL]</div> </td> </tr> <tr> <td align="left" class="title_color" style="color: #848999; font-size: 14px; font-family: " Questrial ", sans-serif; mso-line-height-rule: exactly; line-height: 24px; padding-bottom:15px;"> <div style="line-height: 24px;"> <p>Segue os dados da nova Oportunidade de Negócio criada pelo(a) [NOVORESPONSAVEL] para o parceiro \'[PARCEIRO]\'. <ul> <li> <p>Nome: [NMOPORT] </p> </li> <li> <p>Classificação da Oportunidade: [NMCLASSOPORT] </p> </li> <li> <p>Fase de Negociação: [NMSEQFASENEGO] </p> </li> <li> <p>Tipo De Oportunidade: [IDTPOPORT] </p> </li> <li> <p>Participa da Pipeline: [IDPARTPEPELINE] </p> </li> <li> <p>Valor Previsto: [VRPREVOPORT] </p> </li> </ul></p> <br> </div> </td> </tr> <tr> <td height="10" style="font-size: 10px; line-height: 10px;">&nbsp;</td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> ';
        $mensagem['DSTITULOMENSAGEM'] = 'CRM - Notificação de Nova 0portunidade';
        $mensagem['RESPONSAVEL']      = $this->prospectService->getOperador($cdoperresponsavel, $row['NRORG']);
        $mensagem['PARCEIRO']         = strtoupper($this->prospectService->getParceiro($row['NRPARCOPORT'], $row['NRORG']));
        $mensagem['NOVORESPONSAVEL']  = $this->prospectService->getOperador($row['CDOPERADOR'], $row['NRORG']);
        $mensagem['NMOPORT']          = $row['NMOPORT'];          
        $mensagem['NMCLASSOPORT']     = $row['NMCLASSOPORT'];
        $mensagem['NMSEQFASENEGO']    = $row['NMSEQFASENEGO'];
        $mensagem['IDTPOPORT']        = $row['IDTPOPORT'] === 'N' ? 'Novos Clientes' : 'Clientes' ;
        $mensagem['IDPARTPEPELINE']   = $row['IDPARTPEPELINE'] === 'S' ? 'Sim' : 'Não';
        $mensagem['VRPREVOPORT']      = $row['VRPREVOPORT'] ? $row['VRPREVOPORT'] : 'Sem valor Previsto';
        
        $this->enviarMensagemController->enviarEmail($mensagem, $row['NRORG'], $cdoperresponsavel, $from);
       
    }

    public function searchFields(DTO\Request\Filter $request, DTO\Response $response){
        $dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->fieldsFaseNego_dataSourceName;
        parent::find($request, $response);
        $this->dataSourceName = $dataSourceName;
    }
    
    public function reabrirOportunidade(DTO\Request\Row $request, DTO\Response $response) {
        try{
            $row = $request->getRow();
        
            $this->oportFactory->reabrirOportunidade($row);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
        
    }
    
    public function transferirOportunidade(Row $row, Response $respons){
        $row = $row->getRow();
        $this->oportService->transferirOportunidade($row);
        $this->oportService->evolTransferirOportunidade($row);
     
    }
    
    public function callEnviaEmailTarefa(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        if(is_array($row['OPERADOREMAIL'])) {
            foreach($row['OPERADOREMAIL'] as $oper) {
                self::notificaResponsavelOportunidade($row, $oper['CDOPERADOR']); 
            }
        } else {
            self::notificaResponsavelOportunidade($row, $row['OPERADOREMAIL']); 
        }
    }
    
}