/* Tabela EQESPEPROD: EQESPEPROD */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela EQESPEPROD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela EQESPEPROD,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_COC_EQESPEPROD
AFTER DELETE OR INSERT OR UPDATE
ON EQESPEPROD FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(500);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN      
      IF :OLD.CDPRODEQUIP IS NOT NULL THEN
         V_DESC := V_DESC || ' CdProdEquip=' || :OLD.CDPRODEQUIP;
      END IF;      
     
      IF :OLD.CDESPEPROD IS NOT NULL THEN
         V_DESC := V_DESC || ' CdEspeProd=' || :OLD.CDESPEPROD;
      END IF;
     
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdFilial=' || :OLD.CDFILIAL;
      END IF;
     
      IF :OLD.CDCIA IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCia=' || :OLD.CDCIA;
      END IF;
     
      IF :OLD.CDPRODUTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdProduto=' || :OLD.CDPRODUTO;
      END IF;
     
      IF :OLD.QTEQUISUMA IS NOT NULL THEN
         V_DESC := V_DESC || ' QtEquiSuma=' || :OLD.QTEQUISUMA;
      END IF;
     
      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDPRODEQUIP || '|' || :OLD.CDESPEPROD || '|' || :OLD.CDCIA || '|' || :OLD.CDPRODUTO;
   ELSE
      IF UPDATING THEN
         IF (:OLD.QTEQUISUMA   <> :NEW.QTEQUISUMA ) THEN           
            IF NVL(:OLD.QTEQUISUMA, 0) <> NVL(:NEW.QTEQUISUMA, 0) THEN
               V_DESC := V_DESC || ' QtEquiSuma=' || :OLD.QTEQUISUMA || '|' || :NEW.QTEQUISUMA;
            END IF;
           
            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDPRODEQUIP || '|' || :OLD.CDESPEPROD || '|' ||  :OLD.CDCIA || '|' || :OLD.CDPRODUTO;     
         END IF;
      ELSE
         IF NVL(:OLD.CDPRODEQUIP, ' ') <> NVL(:NEW.CDPRODEQUIP, ' ') THEN
            V_DESC := V_DESC || ' CdProdEquip=' || :NEW.CDPRODEQUIP;
         END IF;
        
         IF NVL(:OLD.CDESPEPROD, ' ') <> NVL(:NEW.CDESPEPROD, ' ') THEN
            V_DESC := V_DESC || ' CdEspeProd=' || :NEW.CDESPEPROD;
         END IF;
        
         IF NVL(:OLD.CDFILIAL, ' ') <> NVL(:NEW.CDFILIAL, ' ') THEN
            V_DESC := V_DESC || ' CDFILIAL=' || :NEW.CDFILIAL;
         END IF;
        
         IF NVL(:OLD.CDCIA, ' ') <> NVL(:NEW.CDCIA, ' ') THEN
            V_DESC := V_DESC || ' CdCia=' || :NEW.CDCIA;
         END IF;
        
         IF NVL(:OLD.CDPRODUTO, ' ') <> NVL(:NEW.CDPRODUTO, ' ') THEN
            V_DESC := V_DESC || ' CdProduto=' || :NEW.CDPRODUTO;
         END IF;
        
         IF NVL(:OLD.QTEQUISUMA, 0) <> NVL(:NEW.QTEQUISUMA, 0) THEN
            V_DESC := V_DESC || ' QtEquiSuma=' || :NEW.QTEQUISUMA;
         END IF;
        
         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDPRODEQUIP || '|' || :NEW.CDESPEPROD || '|' || :NEW.CDCIA || '|' || :NEW.CDPRODUTO;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('EQESPEPROD', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_COC_EQESPEPROD','5.85.xxx'); END;
/

